//
//	InputQTMovie.h			This file is a part of the IKAROS project
//						A module for reading images from a QuickTime movie
//
//    Copyright (C) 2001-2003  Christian Balkenius
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

#ifndef INPUTQTMOVIE
#define INPUTQTMOVIE

#include "IKAROS.h"

#ifdef USE_QUICKTIME

namespace qt {
#include <QuickTime/QuickTime.h>
}

class InputQTMovie: public Module {
public:
    qt::Movie		movie;
    qt::Rect		movieBox;
    qt::TimeValue	movieTime;
    qt::GWorldPtr	movieGWorld;

    char *			filename;
    bool			loop;

    int				size_x;
    int				size_y;

    float *			intensity;
    float *			red;
    float *			green;
    float *			blue;

    void			OpenMovie(qt::UInt8 * filename);
    void			GetNextFrame();

    InputQTMovie(char * name, Parameter * p);
    virtual			~InputQTMovie();

    static Module *		Create(char * name, Parameter * p);

    void				Init();
    void				Tick();
};

#endif

#ifndef USE_QUICKTIME
class InputQTMovie {
public:
    static Module * Create(char * name, Parameter * p) { return NULL; }
};
#endif


#endif
