//
//		Constant.cc		This file is a part of the IKAROS project
//						Implements a modules that outputs a constant array
//
//    Copyright (C) 2004 Christian Balkenius
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//	Created: 2004-03-22
//


#include "Constant.h"



Module * Constant::Create(char * name, Parameter * p)
{
    return new Constant(name, p);
}



Constant::Constant(char * name, Parameter * p):
        Module(p)
{
    output		=	NULL;

    // Initialize as one or two dimensional

    int sizex = GetIntValue(p, "outputsize_x", GetIntValue(p, "outputsize", 1));
    int sizey = GetIntValue(p, "outputsize_y", 1);

    data = GetArray("data", sizex*sizey);
    AddOutput("OUTPUT", sizex, sizey);
}



void
Constant::Init()
{
    output		=	GetOutputArray("OUTPUT");
    outputsize	=	GetOutputSize("OUTPUT");	// Use one-dimensional representation internally

    for (int i=0; i<outputsize;i++)
        output[i] = data[i];
}



Constant::~Constant()
{
}



void
Constant::Tick()
{
    // Since the output is constant nothing happens here
}


