//
//	Randomizer.cc		This file is a part of the IKAROS project
// 					Implements a a modules that outputs a random array
//
//    Copyright (C) 2003 Christian Balkenius
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//	Created: 2003-07-14
//


#include "Randomizer.h"

using namespace ikaros;


Module * Randomizer::Create(char * name, Parameter * p)
{
    return new Randomizer(name, p);
}



Randomizer::Randomizer(char * name, Parameter * p):
        Module(p)
{
    output		=	NULL;

    // Initialize as one or two dimensional

    AddOutput("OUTPUT", GetIntValue(p, "outputsize_x", GetIntValue(p, "outputsize", 1)), GetIntValue(p, "outputsize_y", 1));

    minimum		=	GetFloatValue(p, "min", GetFloatValue(p, "minimum", 0.0));  // Still supports old attribute names
    maximum		=	GetFloatValue(p, "max", GetFloatValue(p, "maximum", 1.0));
}



void
Randomizer::Init()
{
    output		=	GetOutputArray("OUTPUT");
    outputsize	=	GetOutputSize("OUTPUT");	// Use one-dimensional internally
}



Randomizer::~Randomizer()
{
}



void
Randomizer::Tick()
{
    random(output, minimum, maximum, outputsize);
}


