hex = [
    '#000', '#111', '#222', '#333', '#444', '#555', '#666', '#777',
    '#888', '#999', '#AAA', '#BBB', '#CCC', '#DDD', '#EEE', '#FFF', '#FFF'];


function Grid(p)
{
	this.inited = false;
	this.graph = new Graph(p, p.module+'.'+p.source);
	this.graph.group.setAttribute("shape-rendering", "crispEdges");
	this.module = p.module;
	this.source = p.source;
	this.width = p.width+4;
	this.height = p.height+4;
	this.max = 1;
	this.scale = 1/this.max;

	this.colors = ['black', 'white'];
	
	if(p.colors)
		this.colors = this.colors.concat(p.colors);
	this.colorcount = this.colors.length;
	
	usesData(this.module, this.source);
}



Grid.prototype.Init = function(data)
{
    this.inited = true;

    d = data[this.module][this.source];

    this.sizey = d.length;
    this.sizex = d[0].length;
    
    var box_width = (this.width-4)/this.sizex;
    var box_height = (this.height-4)/this.sizey;

    this.box = new Array(this.sizey);

    for(var j=0; j<this.sizey; j++)
    {
        this.box[j] = new Array(this.sizex);
        for(var i=0; i<this.sizex; i++)
            this.box[j][i] = this.graph.AddRect(box_width*i, box_height*j+2, box_width, box_height, 'gray', '#1d1d1d');
    }
}



Grid.prototype.Update = function(data)
{
    if(!this.inited) this.Init(data);

    for(var j=this.sizey; j--;)
    {
        var bj = this.box[j];
        var dj = data[this.module][this.source][j];
        for(var i=this.sizex; i--;)
        {	
            var v = dj[i];
            if(v <= 1.0)
            {
                bj[i].setAttribute("fill", hex[Math.round(15.0*this.scale*v)]);
            }
            else
            {
                ix = Math.round(v);
                if(ix < this.colorcount)
                    color = this.colors[ix];
                else
                    color = this.colors[this.colorcount-1];
                this.box[j][i].setAttribute("fill", color);
            }
        }
    }
}

