function Plot(p)
{
	Plot.prototype.Init = function(data)
	{
		this.inited = true;

		this.graph.AddLine(0, this.bottom-this.zero+8, this.width+16, this.bottom-this.zero+8, '#303030', 1);
		this.mark = this.graph.AddLine(0, 2, 0, this.height+16, 'black', 1);
		
		d = data[this.module][this.source];
		
		this.buffer = new Array();
		for(i in this.select)
		{
			c = (this.colors && this.colors[i] ? this.colors[i] : 'black');
			var n = new Array();
			this.buffer.push(n);
			for(var k=0; k<this.width; k++)
				n.push(this.graph.AddLine(k+8, this.bottom-this.zero+8, k+1+8, this.bottom-this.zero+8, c, 1));
		}
		
		this.graph.AddText(this.width-1+8, 10+8, this.max, 40, 12, 'end');
		this.graph.AddText(this.width-1+8, this.height-3+8, this.min, 40, 12, 'end');

	}

	Plot.prototype.Update = function(data)
	{
		if(!this.inited) this.Init(data);

		d = data[this.module][this.source];
		
		for(n in this.buffer)
		{
			v = this.scale*(d[this.select[n][0]][this.select[n][1]]-this.min);
			this.buffer[n][this.position].setAttribute('y2', this.bottom - v+8);
			if(this.position>0)
				this.buffer[n][this.position].setAttribute('y1', this.buffer[n][this.position-1].getAttribute('y2'));
			else
				this.buffer[n][this.position].setAttribute('y1', this.buffer[n][this.width-1].getAttribute('y2'));
		}
		
		this.position++;
		if(this.position >= this.width)
			this.position = 0;

		this.mark.setAttribute('x1', this.position+8);
		this.mark.setAttribute('x2', this.position+8);
	}

	this.inited = false;
	this.graph = new Graph(p, p.module+'.'+p.source);
	this.module = p.module;
	this.source = p.source;
	this.width = p.width-16;
	this.height = p.height-16;
	this.min = (p.min ? p.min : 0);
	this.max = (p.max ? p.max : 1);
	this.scale = (this.height-6)/(this.max-this.min);
	this.zero = this.scale*(0-this.min);
	this.bottom = this.height-3;
	this.position = 1;

	this.select = (p.select ? p.select : [[0,0]]);
	this.colors = p.colors;
	
	usesData(this.module, this.source);
}
