var svgns = "http://www.w3.org/2000/svg";
var xlinkns = "http://www.w3.org/1999/xlink";
var clip_id = 0;

function Graph(p, title)
{
	Graph.prototype.AddRect = function (x, y, width, height, f, s, radius)
	{
		r = document.createElementNS(svgns,"rect");	
		r.setAttribute('x', x);
		r.setAttribute('y', y);
		r.setAttribute('width', width);
		r.setAttribute('height', height);
		if(f) r.setAttribute('fill', f);
		if(s) r.setAttribute('stroke', s);
		if(radius) r.setAttribute('rx', radius);
		if(radius) r.setAttribute('ry', radius);
		
		this.group.appendChild(r);
		
		return r;
	}
	
	Graph.prototype.AddClippingRect= function (x, y, width, height)
	{
		clip_id++;

		g = document.createElementNS(svgns,"g");

		g.setAttribute('clip-path', 'url(#clip'+clip_id+')');
		
		cp = document.createElementNS(svgns,"clipPath");
		cp.setAttribute('id', 'clip'+clip_id);
		
		g.appendChild(cp);
		
		cr = document.createElementNS(svgns,"rect");
		cr.setAttribute('x', y);
		cr.setAttribute('y', y);
		cr.setAttribute('width', width);
		cr.setAttribute('height', height);

		cp.appendChild(cr);
		
		this.group.appendChild(g);
		
		return g;
	}
	
	Graph.prototype.AddCircle = function (cx, cy, radius, f, s, sw)
	{
		r = document.createElementNS(svgns,"circle");	
		r.setAttribute('cx', cx);
		r.setAttribute('cy', cy);
		r.setAttribute('r', radius);

		if(f) r.setAttribute('fill', f);
		if(s) r.setAttribute('stroke', s);
		if(sw) r.setAttribute('stroke-width', sw);

		this.group.appendChild(r);
		
		return r;
	}
	
	Graph.prototype.AddLine = function (x1, y1, x2, y2, s, sw)
	{
		r = document.createElementNS(svgns,"line");	
		r.setAttribute('x1', x1);
		r.setAttribute('y1', y1);
		r.setAttribute('x2', x2);
		r.setAttribute('y2', y2);

		if(s) r.setAttribute('stroke', s);
		if(sw) r.setAttribute('stroke-width', sw);

		this.group.appendChild(r);
		
		return r;
	}
	
	Graph.prototype.AddImage = function (x, y, width, height, path)
	{
		r = document.createElementNS(svgns,"image");	
		r.setAttribute('x', x);
		r.setAttribute('y', y);
		r.setAttribute('width', width);
		r.setAttribute('height', height);
		r.setAttribute('preserveAspectRatio', 'none');
		r.setAttributeNS(xlinkns, 'href', path);

		this.group.appendChild(r);
		
		return r;
	}
	
	Graph.prototype.AddText = function (x, y, t, width, height, anchor)
	{
		r = document.createElementNS(svgns,"text");	
		r.setAttribute('x', x);
		r.setAttribute('y', y);
		r.setAttribute('style', 'font-size:11px;font-family:sans-serif;fill:#BABABA;');
		if(anchor) r.setAttribute('text-anchor', anchor);
		r.setAttribute('text-rendering','optimizeLegibility');
		tn = document.createTextNode(t);	
		r.appendChild(tn);
		this.group.appendChild(r);
		
		return r;
	}
	
	clip_id++;
	this.clip = document.createElementNS(svgns,"clipPath");
	this.clip.setAttribute('id', 'clip'+clip_id);
	document.documentElement.appendChild(this.clip);

	this.clipRect = document.createElementNS(svgns,"rect");
	this.clipRect.setAttribute('x', '0');
	this.clipRect.setAttribute('y', '-22');
	this.clipRect.setAttribute('rx', '10');
	this.clipRect.setAttribute('ry', '10');
	this.clipRect.setAttribute('width', p.width);
	this.clipRect.setAttribute('height', p.height+23);
	this.clip.appendChild(this.clipRect);

	this.group = document.createElementNS(svgns,"g");
	this.group.setAttribute("clip-path", 'url(#clip'+clip_id+')');
	this.group.setAttribute("transform", "translate("+p.x+","+p.y+")");
	
	if(!p.title)
		p.title = title;

	if(!p.frame || !(p.frame == 'none' || p.frame == 'invisible'))
	{
		this.header = this.AddRect(0, -22, p.width, 20+p.height, '#1D1D1D', '#1D1D1D', 10);
		this.line = this.AddLine(-1, 0.5, p.width+2, 0.5, '#303030', 2);
		this.title = this.AddText(10, -8, p.title);
	}

	document.documentElement.appendChild(this.group);
}



var uiobject = new Array(0);

function ignore_data(obj)
{
}


function get(url, callback)
{
	function getURL_alt(url, callback)
	{
		function callCallback()
		{
			if (ajaxRequest.readyState == 4)
			{
				if(ajaxRequest.status == 200)
					if (ajaxCallback) ajaxCallback({content:ajaxRequest.responseText});
				else
					alert("Returned status code " + ajaxRequest.status);
			}
		}

		var ajaxRequest = null;
		var ajaxCallback = callback;

		ajaxRequest = new XMLHttpRequest();
		ajaxRequest.onreadystatechange = callCallback;
		ajaxRequest.open("GET", url, true);
		ajaxRequest.send(null);
	}			

	if(window.getURL)
		getURL(url, callback);
	else if(window.XMLHttpRequest)
		getURL_alt(url, callback);
	else
		alert("Error: This web browser does not have getURL or XMLHttpRequest");
}



var running = false;
var fastforward = false;

function step()
{
	function handle_data_object(obj)
	{
		var data = eval("("+obj.content+")");
        for(i in uiobject)
			uiobject[i].Update(data);
		iteration.nodeValue = data.iteration;
	}

	get("step", handle_data_object);
}



function runstep()
{
    if(!running)
        return;

	function handle_data_object(obj)
	{
		var data = eval("("+obj.content+")");
        for(i in uiobject)
			uiobject[i].Update(data);
		iteration.nodeValue = data.iteration;
		if(running)
			setTimeout("runstep();", 10);
	}

	get("runstep", handle_data_object);
}



function faststep()
{
    if(!fastforward)
        return;

	function handle_data_object(obj)
	{
		var data = eval("("+obj.content+")");
		iteration.nodeValue = data.iteration;
		if(fastforward)
			setTimeout("faststep();", 0);
	}

	get("faststep", handle_data_object);
}



function run()
{
	running = true;
    fastforward = false;
    runstep();
}



function pause()
{
	function handle_data_object(obj)
	{
		var data = eval("("+obj.content+")");
		for(i in uiobject)
			uiobject[i].Update(data);
		iteration.nodeValue = data.iteration;
	}

	running = false;
    fastforward = false;

	get("pause", handle_data_object);
}



function stop()
{
	function handle_data_object(obj)
	{
	}

	running = false;
    fastforward = false;
	get("stop", handle_data_object);
}



function fast()
{
	running = false;
    fastforward = true;
	faststep();
}



function free()
{
	running = false;
    fastforward = false;
	get("free", ignore_data);
}



function update()
{
	function handle_data_object(obj)
	{
		var data = eval("("+obj.content+")");
		for(i in uiobject)
			uiobject[i].Update(data);
		iteration.nodeValue = data.iteration;
        
        if(data.state == 3)
            do_run();
        else if(data.state == 4)
            do_fast();
        else if(data.state == 5)
            do_free();
	}

	get("update", handle_data_object);
}



function add(obj)
{
	uiobject.push(obj);
}



function usesData(module, source)
{
	get("uses/"+module+'/'+source, ignore_data);
}


